/*  TINYBUG.C
 *  this program contains a tiny bug
 *  last mod.: 7-OCT-91
 */

#include <STDIO.H>
#include <L_MEM.H>

Far_ptr ptr[1000];
char *usage = "\nUse TINYBUG to run without the memory log"
       "\n or TINYBUG 1 to run with the memory log.\n"
       "\nThis program allocates %lu-byte blocks and frees them.";

/*---------------------------*/
void main(int argc,char **argv)
{
int i, err_flag, num_blocks;
Ulong block_size=2000L;
int log=FALSE;

mem_alloc(2016,&err_flag);
printf(usage,block_size);
if ( argc > 1 )
    {
    log = TRUE;
    printf("\nA summary log report is then displayed, "
        "and the log is erased.\n");
    }

printf("\nLargest available block: %lu bytes.",mem_max(&err_flag));

if ( log )
    set_mem_log(TRUE);

/*  allocate memory blocks until insufficient memory  */
printf("\nNow allocating blocks ... ");
num_blocks = 0;
i = 0;
while ( TRUE )
    {
    ptr[i++] = mem_alloc(block_size,&err_flag);
    if ( err_flag )         /*  if error  */
        break;              /*  exit loop  */
    else                    /*  else  */
        num_blocks++;       /*  increment block count  */
    }
printf("  %d blocks allocated.",num_blocks);

/*  now free the blocks  */
printf("\nNow freeing blocks ... ");

/*  decrement i to compensate for NULL pointer
 *  returned by last mem_alloc()
 */
i--;

while ( num_blocks-- > 0 )
    {
    mem_free(ptr[i--],&err_flag);
    if ( err_flag == BLOCK_ALREADY_FREED )
        {
        printf("\nBlock already freed.");
        return;
        }
    }

printf("done.");

if ( log )
    {
    printf("\nNow producing report #3:");
    mem_log_report(3,stdout,0,FALSE,&err_flag);
    printf("\nNow erasing log ... ");
    mem_erase_log(&err_flag);
    printf("done.");
    }

printf("\nLargest available block: %lu bytes.\n",mem_max(&err_flag));
}
